---
.build:
  extends: .base
  stage: build
  needs: []
  variables:
    PACKAGE_NAME: ${CI_PROJECT_NAME}-${PACKAGE_VERSION}-${PACKAGE_ARCH}
  script:
    - cmake -DPACKAGE_NAME=${CI_PROJECT_NAME} -DPACKAGE_VERSION=${PACKAGE_VERSION} -DPACKAGE_ARCH=${PACKAGE_ARCH} -S . -B build-${PACKAGE_ARCH} --preset default
    - cmake --build build-${PACKAGE_ARCH}
  artifacts:
    paths:
      - build-${PACKAGE_ARCH}
    expire_in: 1 week

build:python:
  extends: .base
  stage: build
  needs: []
  script:
    - mkdir -p out/dist/bin
    - sed -i '/version = "0.0.0"/c\version = "'$(eval echo ${PYTHON_PACKAGE_VERSION})'"' src/${PYTHON_PACKAGE_NAME}/pyproject.toml
    - cat src/${PYTHON_PACKAGE_NAME}/pyproject.toml
    - python3 -m build src/${PYTHON_PACKAGE_NAME}
    - pyinstaller --clean -F --distpath out/dist/bin src/${PYTHON_PACKAGE_NAME}/${PYTHON_PACKAGE_NAME}/module.py --name ${PYTHON_PACKAGE_NAME}
    - cp src/${PYTHON_PACKAGE_NAME}/dist/*.whl out/dist
  artifacts:
    paths:
      - out
    expire_in: 1 week
